/*	version.h

	AFAPI version information.

	September 1998 by H.G. Dietz and T.I. Mattox
*/


#ifndef _P_VERSION_H
#define _P_VERSION_H

#ifndef AFAPI
/* The AFAPI mechanism should be specified by the Makefile */
#error	The target AFAPI mechanism must be defined.  Please use the Makefile.
#endif

#define	AFAPI_VERSION	"19991222"	/* The AFAPI version */

/*	Revision History:
	
19991222  Improved doc/VWLib.install, tweaked a variety of files
19991221  Hank updated the README for the change of project home to UKY
19991220  vwmain.c: Added VWMAXWALLS & bounds checking to VWSPACE parsing code
19991217  config: Added functionality & questions relating to VWLIB
  Revised Makefiles so that VWlib files will compiled if VWLib was configured
  pz.c: removed extranious debugging code
  vwmouse.c: made it take configuration information from AFAPI/config.h
  ttltester.c: made NPROC == 1 not fail, but doesn't do anything usefull yet
  begain outlining doc/VWLib.install
19991215  vwfb.c: Fixed method for getting screen settings info.
  vwfb.c: added a call to /usr/bin/setterm to turn off/on the cursor
  various other misc. changes for VWLIB integration
19991214  Made version number Y2K compliant.
  Begain merging the video wall library code into the AFAPI package.
  Added src/VW directory and its contents: the video wall source code
  Modified src/Makefile to be able to build the lib/libVW*.a files
  Added include/AFAPI/vwsup.h  Added examples/pz.c
  Modified af* scripts to export VWLIB and VWSPACE
991208	AFAPI_LOCKFILE now in /var/lock as per Filesystem Hierarchy Standard
	Renamed AFAPI_LOCKS to AFAPI_PIDD since the contents are not lockfiles
	There are still issues with "housekeeping" cron jobs messing with
	long running programs, such as AFAPI's ttltester.
	Added code to allow & special case NPROC == 1, most fns just return.
991007	Removed legacy afcleanup support from afscripts, tweaked lockdir usage
	Added P_NON_STANDARD_PORT switch for generic add-on parallel ports
	Tweaked these files in src/ to get rid of compiler warnings:
		afreset.c	afdiscon.c	ttltester.c	portinfo.c
		TTL_PAPERS/intern.h		TTL_PAPERS/control.c
		WAPERS/intern.h			WAPERS/control.c
	Tried to bring doc/NFS.available up-to-date, but too many things are
	different now, so I added a disclaimer that it is out of date. - Tim
	Updated doc/assumptions (use of a Firewall and /bin/sh)
990618	Added afinit script, updated doc/cluster.install, lockfile use modifed
	Added P_USE_IOPL switch for LAVA cards, etc. default is ioperm()
990521	Hacked version for lava card test: uses iopl() instead of ioperm()
98????	Hank removed the requirement for /bin/sh as your default shell
980930	Removed the mus.c example, and added comments about SHMAPERS to config
980929	Added a function prototype for ioperm() to a variety of files
980922	Fixed a few more bugs in the Makefiles
980920	Begain updating and simplifying the documentation
980918	Updated makefiles to work with the unified release.
980914	Made inline.h work properly for user's progs with the unified release.
980911	Continued the grand unification...
980910	Started the Grand Unification Release conversion... GUR AFAPI:)

earlier	Too many bugs to list have been fixed... all previous versions of
	AFAPI should be replaced.  This is a partial list of routines that
	have been updated, enhanced, added, or just plain fixed:

	scan/reduce Min/Max/Add/Mul for 1u
	p_first		p_quantify	p_count		p_voteCount
	p_all2all	p_all2allz	p_bcastGetz	p_*bar()
	p_scatPutz	p_scatGetz	p_gatherz	p_putGetz
	p_scanAdd*	p_scanMul*	p_scanAnd*	p_scanOr*
	p_reduceXor*	reduce*64	p_waitbar	p_bcastGet16u
*/

#endif
