/*	scan.c

	AFAPI scan (parallel prefix) function definitions for
	SHMAPERS.

	July 1996 by H. Dietz
*/
#if	NPROC > 1


#include "intern.h"

/*	p_scanAnd() functions...
*/

#define	P_DECLARE(suffix) \
p_##suffix \
p_scanAnd##suffix(register p_##suffix datum) \
{ \
	register volatile p_shm_type *p = p_shm_all; \
	register volatile p_shm_type *q = (p + NPROC); \
	register int barno = p_shm_me->barno + 1; \
	register int which = (barno & 1); \
	register int barnonext = (barno + 1); \
 \
	/* Install my datum and then signal barrier */ \
	p_shm_me->datum[ which ].u_##suffix = P_CAST_##suffix(datum); \
	p_shm_me->barno = barno; \
 \
	/* Now wait for everybody else... */ \
	do { \
		register int hisbarno = p->barno; \
		if (hisbarno == barnonext) goto syncd; \
		if (hisbarno != barno) { \
			do { \
				P_SHM_IDLE; \
				hisbarno = p->barno; \
				if (hisbarno == barnonext) goto syncd; \
			} while (hisbarno != barno); \
		} \
	} while (++p < q); \
 \
syncd: \
	/* Process the values... */ \
	p = p_shm_all; \
	do { \
		((p_##suffix##u) datum) &= \
			((p_##suffix##u) p->datum[ which ].u_##suffix); \
	} while (++p <= p_shm_me); \
 \
	return(datum); \
}

P_BETA

#undef	P_DECLARE

/*	p_scanOr() functions...
*/

#define	P_DECLARE(suffix) \
p_##suffix \
p_scanOr##suffix(register p_##suffix datum) \
{ \
	register volatile p_shm_type *p = p_shm_all; \
	register volatile p_shm_type *q = (p + NPROC); \
	register int barno = p_shm_me->barno + 1; \
	register int which = (barno & 1); \
	register int barnonext = (barno + 1); \
 \
	/* Install my datum and then signal barrier */ \
	p_shm_me->datum[ which ].u_##suffix = P_CAST_##suffix(datum); \
	p_shm_me->barno = barno; \
 \
	/* Now wait for everybody else... */ \
	do { \
		register int hisbarno = p->barno; \
		if (hisbarno == barnonext) goto syncd; \
		if (hisbarno != barno) { \
			do { \
				P_SHM_IDLE; \
				hisbarno = p->barno; \
				if (hisbarno == barnonext) goto syncd; \
			} while (hisbarno != barno); \
		} \
	} while (++p < q); \
 \
syncd: \
	/* Process the values... */ \
	p = p_shm_all; \
	do { \
		((p_##suffix##u) datum) |= \
			((p_##suffix##u) p->datum[ which ].u_##suffix); \
	} while (++p <= p_shm_me); \
 \
	return(datum); \
}

P_BETA

#undef	P_DECLARE

/*	p_scanXor() functions...
*/

#define	P_DECLARE(suffix) \
p_##suffix \
p_scanXor##suffix(register p_##suffix datum) \
{ \
	register volatile p_shm_type *p = p_shm_all; \
	register volatile p_shm_type *q = (p + NPROC); \
	register int barno = p_shm_me->barno + 1; \
	register int which = (barno & 1); \
	register int barnonext = (barno + 1); \
 \
	/* Install my datum and then signal barrier */ \
	p_shm_me->datum[ which ].u_##suffix = P_CAST_##suffix(datum); \
	p_shm_me->barno = barno; \
 \
	/* Now wait for everybody else... */ \
	do { \
		register int hisbarno = p->barno; \
		if (hisbarno == barnonext) goto syncd; \
		if (hisbarno != barno) { \
			do { \
				P_SHM_IDLE; \
				hisbarno = p->barno; \
				if (hisbarno == barnonext) goto syncd; \
			} while (hisbarno != barno); \
		} \
	} while (++p < q); \
 \
syncd: \
	/* Process the values... */ \
	datum = 0; \
	p = p_shm_all; \
	do { \
		((p_##suffix##u) datum) ^= \
			((p_##suffix##u) p->datum[ which ].u_##suffix); \
	} while (++p <= p_shm_me); \
 \
	return(datum); \
}

P_BETA

#undef	P_DECLARE

/*	p_scanMin() functions...
*/

p_1u
p_scanMin1u(register p_1u datum)
{
	return(p_scanAnd1u(datum));
}

#define	P_DECLARE(suffix) \
p_##suffix \
p_scanMin##suffix(register p_##suffix datum) \
{ \
	register volatile p_shm_type *p = p_shm_all; \
	register volatile p_shm_type *q = (p + NPROC); \
	register int barno = p_shm_me->barno + 1; \
	register int which = (barno & 1); \
	register int barnonext = (barno + 1); \
 \
	/* Install my datum and then signal barrier */ \
	p_shm_me->datum[ which ].u_##suffix = P_CAST_##suffix(datum); \
	p_shm_me->barno = barno; \
 \
	/* Now wait for everybody else... */ \
	do { \
		register int hisbarno = p->barno; \
		if (hisbarno == barnonext) goto syncd; \
		if (hisbarno != barno) { \
			do { \
				P_SHM_IDLE; \
				hisbarno = p->barno; \
				if (hisbarno == barnonext) goto syncd; \
			} while (hisbarno != barno); \
		} \
	} while (++p < q); \
 \
syncd: \
	/* Process the values... */ \
	p = p_shm_all; \
	do { \
		register p_##suffix t = p->datum[ which ].u_##suffix; \
		if (t < datum) datum = t; \
	} while (++p <= p_shm_me); \
 \
	return(datum); \
}

P_DECLARE(8)
P_DECLARE(8u)
P_DECLARE(16)
P_DECLARE(16u)
P_DECLARE(32)
P_DECLARE(32u)
P_DECLARE(64)
P_DECLARE(64u)
P_DECLARE(ptr)
P_DECLARE(bar)
P_DECLARE(32f)
P_DECLARE(64f)

#undef	P_DECLARE

/*	p_scanMax() functions...
*/

p_1u
p_scanMax1u(register p_1u datum)
{
	return(p_scanOr1u(datum));
}

#define	P_DECLARE(suffix) \
p_##suffix \
p_scanMax##suffix(register p_##suffix datum) \
{ \
	register volatile p_shm_type *p = p_shm_all; \
	register volatile p_shm_type *q = (p + NPROC); \
	register int barno = p_shm_me->barno + 1; \
	register int which = (barno & 1); \
	register int barnonext = (barno + 1); \
 \
	/* Install my datum and then signal barrier */ \
	p_shm_me->datum[ which ].u_##suffix = P_CAST_##suffix(datum); \
	p_shm_me->barno = barno; \
 \
	/* Now wait for everybody else... */ \
	do { \
		register int hisbarno = p->barno; \
		if (hisbarno == barnonext) goto syncd; \
		if (hisbarno != barno) { \
			do { \
				P_SHM_IDLE; \
				hisbarno = p->barno; \
				if (hisbarno == barnonext) goto syncd; \
			} while (hisbarno != barno); \
		} \
	} while (++p < q); \
 \
syncd: \
	/* Process the values... */ \
	p = p_shm_all; \
	do { \
		register p_##suffix t = p->datum[ which ].u_##suffix; \
		if (t > datum) datum = t; \
	} while (++p <= p_shm_me); \
 \
	return(datum); \
}

P_DECLARE(8)
P_DECLARE(8u)
P_DECLARE(16)
P_DECLARE(16u)
P_DECLARE(32)
P_DECLARE(32u)
P_DECLARE(64)
P_DECLARE(64u)
P_DECLARE(ptr)
P_DECLARE(bar)
P_DECLARE(32f)
P_DECLARE(64f)

#undef	P_DECLARE

/*	p_scanAdd() functions...
*/

p_1u
p_scanAdd1u(register p_1u datum)
{
	return(p_scanOr1u(datum));
}

#define	P_DECLARE(suffix) \
p_##suffix \
p_scanAdd##suffix(register p_##suffix datum) \
{ \
	register volatile p_shm_type *p = p_shm_all; \
	register volatile p_shm_type *q = (p + NPROC); \
	register int barno = p_shm_me->barno + 1; \
	register int which = (barno & 1); \
	register int barnonext = (barno + 1); \
 \
	/* Install my datum and then signal barrier */ \
	p_shm_me->datum[ which ].u_##suffix = P_CAST_##suffix(datum); \
	p_shm_me->barno = barno; \
 \
	/* Now wait for everybody else... */ \
	do { \
		register int hisbarno = p->barno; \
		if (hisbarno == barnonext) goto syncd; \
		if (hisbarno != barno) { \
			do { \
				P_SHM_IDLE; \
				hisbarno = p->barno; \
				if (hisbarno == barnonext) goto syncd; \
			} while (hisbarno != barno); \
		} \
	} while (++p < q); \
 \
syncd: \
	/* Process the values... */ \
	p = p_shm_all; \
	datum = 0; \
	do { \
		datum += p->datum[ which ].u_##suffix; \
	} while (++p <= p_shm_me); \
 \
	return(P_CAST_##suffix(datum)); \
}

P_DECLARE(8)
P_DECLARE(8u)
P_DECLARE(16)
P_DECLARE(16u)
P_DECLARE(32)
P_DECLARE(32u)
P_DECLARE(64)
P_DECLARE(64u)
P_DECLARE(32f)
P_DECLARE(64f)


#undef P_DECLARE

/*	p_scanMul() functions...
*/

p_1u
p_scanMul1u(register p_1u datum)
{
	return(p_scanAnd1u(datum));
}

#define	P_DECLARE(suffix) \
p_##suffix \
p_scanMul##suffix(register p_##suffix datum) \
{ \
	register volatile p_shm_type *p = p_shm_all; \
	register volatile p_shm_type *q = (p + NPROC); \
	register int barno = p_shm_me->barno + 1; \
	register int which = (barno & 1); \
	register int barnonext = (barno + 1); \
 \
	/* Install my datum and then signal barrier */ \
	p_shm_me->datum[ which ].u_##suffix = P_CAST_##suffix(datum); \
	p_shm_me->barno = barno; \
 \
	/* Now wait for everybody else... */ \
	do { \
		register int hisbarno = p->barno; \
		if (hisbarno == barnonext) goto syncd; \
		if (hisbarno != barno) { \
			do { \
				P_SHM_IDLE; \
				hisbarno = p->barno; \
				if (hisbarno == barnonext) goto syncd; \
			} while (hisbarno != barno); \
		} \
	} while (++p < q); \
 \
syncd: \
	/* Process the values... */ \
	p = p_shm_all; \
	datum = 1; \
	do { \
		datum *= p->datum[ which ].u_##suffix; \
	} while (++p <= p_shm_me); \
 \
	return(datum); \
}

P_DECLARE(8)
P_DECLARE(8u)
P_DECLARE(16)
P_DECLARE(16u)
P_DECLARE(32)
P_DECLARE(32u)
P_DECLARE(64)
P_DECLARE(64u)
P_DECLARE(32f)
P_DECLARE(64f)

#undef P_DECLARE
#endif /* if NPROC > 1 */
